
package cz.upol.pja.lecture07.beans;

import cz.upol.pja.lecture07.api.Prettifier;
import cz.upol.pja.lecture07.api.Style;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.inject.Produces;

@RequestScoped
public class PrettifierSource {
    
    @Produces @Style(desc = "basic")
    public Prettifier getBasicPrettifier() {
        return create(" ");
    }
    
    @Produces @Style(desc = "decent")
    public Prettifier getDecentPrettifier() {
        return create("-");
    }
    
    @Produces @Style(desc = "positive")
    public Prettifier getPositivePrettifier() {
        return create("+");
    }
    
    
    private Prettifier create(String decoration) {
        
        return new Prettifier() {
            @Override
            public String prettify(String str) {
                if (str.length() == 0) return "";
                StringBuilder sb = new StringBuilder();
                sb.append(str.charAt(0));
                for (int i = 0; i < str.length(); i++) {
                    sb.append(decoration).append(str.charAt(i));
                }
                sb.append(decoration);
                return sb.toString();
            }
        };
    }
}
    

