
package cz.upol.pja.lecture07.web;

import cz.upol.pja.lecture07.model.Quote;
import cz.upol.pja.lecture07.api.QuoteTest;
import java.util.List;
import java.util.Map;
import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

@RequestScoped
@Named("testCtl")
public class TestCtl {
    
    private static final int OPTIONS = 3;
    private static final int QUOTES = 10;
    
    @Inject
    private QuoteTest quoteTest;

    public TestCtl() {
    }
    
    public String start() {
        quoteTest.startNewTest(QUOTES);
        return "";
    }
    
    public String getQuote() {
        return quoteTest.getCurrentQuery();
    }
    
    public List<String> getOptions() {
        return quoteTest.getChoices(OPTIONS);
    }
    
    public String reportAnswer(String author) {
        quoteTest.setAnswer(author);
        return "";
    }
    
    public Map<Quote, String> getAnswers() {
        return quoteTest.getAnswers();
    }
    
    public int getTotalQuotes() {
        return quoteTest.getTotalQuestions();
    }
    
    public int getAnsweredQuotes() {
        return quoteTest.getAnsweredQuestions();
    }
    
    public boolean isComplete() {
        return (quoteTest.getTotalQuestions() > 0) 
                && (quoteTest.getTotalQuestions() == quoteTest.getAnsweredQuestions());
    }
    
    public boolean isInitilized() {
        return quoteTest.getCurrentQuery() != null;
    }
}
